<template>
  <PageCard
    class="signIn_wrapper"
    :title="$t('authorization.step3.part3.enterRecovery')"
    :bordering="false"
    gradient>
    <div class="signIn_inner">
      <div class="signIn_inner-body flex flex-center">
        <div class="signIn_inner-description">
          {{$t('authorization.step3.part3.description')}}
        </div>
      </div>
      <div class="signIn_inner-body">
        <div class="mnemonics no-border">
          <div class="mnemonics_col">
            <div
              class="mnemonics_item"
              v-for="(item, key) in mnemonicsFirst"
              :key="key">
              <div class="mnemonics_item-number">{{key+1}}</div>
              <div class="mnemonics_item-text">
                <input
                  class="mnemonics_item-input"
                  type="text"
                  :value="item"
                  @paste="paste($event, key, 'mnemonicsFirst')"
                  @input="(e)=>handleChangeInput(item, e.target.value, 'mnemonicsFirst', key)"></div>
            </div>
          </div>
          <div class="mnemonics_col">
            <div
              class="mnemonics_item"
              v-for="(item, key) in mnemonicsSecond"
              :key="key">
              <div class="mnemonics_item-number">{{key+13}}</div>
              <div class="mnemonics_item-text">
                <input
                  class="mnemonics_item-input"
                  type="text"
                  :value="item"
                  @paste="paste($event, key, 'mnemonicsSecond')"
                  @input="(e)=>handleChangeInput(item, e.target.value, 'mnemonicSecond', key)"></div>
            </div>
          </div>
        </div>
        <div class="flex flex-center">
          <Btn
            :disabled="emptyMnemonics"
            @click="login">{{$t('authorization.login')}}
          </Btn>
        </div>
      </div>
    </div>
  </PageCard>
</template>

<script>
  import Btn from '~/components/UI/BtnSign';
  import {Wallet} from "~/services/wallet";
  import PageCard from '~/components/UI/PageCard';

  export default {
    name: "Step3_ThePart3",
    props: {
      active: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        emptyMnemonics: true,
        mnemonicsFirst: [],
        mnemonicsSecond: [],
        mnemonics: ''
      }
    },
    components: {
      Btn,
      PageCard
    },
    computed: {},
    methods: {
      paste(e, key, arrayName) {
        this.emptyMnemonics = true;
        let paste = (e.clipboardData || window.clipboardData).getData('text');
        if (!paste) return;
        const arr = paste.split(' ').filter(i => i.trim());
        this.$nextTick(_ => {
          if (arr.length === 24) {
            this.mnemonicsFirst = [];
            this.mnemonicsSecond = [];
            for (let i = 0; i <= 11; i++) {
              this.mnemonicsFirst.push(arr[i]);
              this.mnemonicsSecond.push(arr[i + 12]);
              this.emptyMnemonics = false;
            }
            e.preventDefault();
          }
        });
      },
      handleChangeInput(oldVal, newVal, arr, key) {
        this[arr][key] = newVal;
      },
      formatInputs() {
        for (let i = 1; i <= 12; i++) {
          this.mnemonicsFirst.push('');
          this.mnemonicsSecond.push('');
        }
      },
      login() {
        let mnemonic = '';
        for (let i = 0; i <= 11; i++) {
          mnemonic += this.mnemonicsFirst[i] + ' ';
          mnemonic += this.mnemonicsSecond[i] + ' ';
        }
        Wallet.getKeys(mnemonic).then(keys => {
          const privateKeys = keys.privateKey.split(':');
          const publicKeys = keys.publicKey.split(':');
          this.$emit('finish', {
            privateKeys,
            publicKeys
          });
        }).catch(e => {
          console.log('wrong mnemonic - ', e);
        });
      }
    },
    mounted() {
      this.formatInputs();
    }
  }
</script>
